Subject: Pine Frequently Asked Questions

From: Pine Development Team <[email-masked]>
Date: Fri, 16 sep 94 09:41:16 -0700

Subject: Contents

                        PINE FREQUENTLY ASKED QUESTIONS
                                       
   The following questions have been compiled from questions asked on the
   pine-info and pine-bugs mailing lists.
   
General

     * What is Pine? 
     * What is MIME? 
     * What is IMAP? 
     * How can I get a copy of Pine? 
     * Is there a manual? 
     * What mailing lists and newsgroups are there dealing with Pine? 
     * What are all these funny names in your examples? 
     * How many sites use Pine? 
       
Errors and Problems

     * I have found a bug in Pine 3.05. Could you please fix it? 
     * If I postpone a Reply, there is no 'A' in the index after I resume
       and send it. 
     * "Folder Format Invalidated (consult an expert), aborted" 
     * What is folder locking and how does it work? 
     * What happens when two Pine sessions access the same mailbox
       simultaneously? 
     * Why did I get the message "locked, override in XXX sec"? 
     * Why is a charset=US-ASCII attachment sent using BASE64 
       encoding?

Usage

     * How do I keep all of the names from showing up at the top of the
       message?
       
     * How do I use Ispell with Pine (and Pico)? 
     * How can I have a signature automatically appended to my mail
       messages? 
     * How do I read News with Pine? 
     * Can I post news with Pine? 
     * How do I "paste" an address from the addressbook into the text of
       a message? 
     * How can I filter messages into different incoming folders? 
     * Can I define a Reply-To: header? 
     * Can I execute Pine from a shell script so I can use my
       addressbook? 
     * xbiff lets me know about new mail, but pine doesn't know about it.
     * How can I read a ROT13 encoded message? 
       
Installation and Configuration

     * Can Kerberos or AFS authentication be used with Pine? 
     * Can PC-Pine be used with a POP server? 
     * What is a Tenex mailbox and why should I use it? 
     * Where does Unix Pine look for configuration information? 
     * Where does PC-Pine look for configuration information? 
     * How do I make Pine work with my older terminal? 
     * How do I configure Pine to not leave mail in /usr/spool/mail? 
       
Platform Specific

     * To what platforms has Pine been ported? 
     * Pine 3.89 on an IBM RS/6000 running AIX 3.2.3 crashes every time I
       try to open a folder. 
     * What PC comm software works with the "Print to ANSI" print option?
     * What Mac comm software works with the "Print to ANSI" print
       option? 
     * What Amiga comm software works with the "Print to ANSI" print
       option? 
       
Conversions

     * How can someone without a MIME-aware mail program decipher an
       attachment? 
     * How do I convert a Sun Mailtool attachment to MIME format? 
     * How do I convert Berkeley Mail aliases to Pine Addressbook? 
     * How do I convert Elm aliases to Pine Addressbook? 
       
Development Info

     * What are the current versions of Pine and related software? 
     * What is new in this version of Pine? 
     * When is the next release of Pine (tentatively) scheduled? 
     * What new features will the next release of Pine include? 

Subject: What is Pine?

   Pine(tm) --a Program for Internet News & Email-- is a tool for
   reading, sending, and managing electronic messages.  It was designed
   specifically with novice computer users in mind, but can be tailored
   to accommodate the needs of "power users" as well.  Pine uses
   Internet message protocols (e.g. RFC-822, SMTP, MIME, IMAP, NNTP) and
   runs on Unix and PCs. 
  
   The guiding principles for Pine's user-interface were:  careful
   limitation of features, one-character mnemonic commands,
   always-present command menus, immediate user feedback, and high
   tolerance for user mistakes.  It is intended that Pine can be learned
   by exploration rather than reading manuals.  It has the ability to
   perform full screen editing of messages, attachments (such as Word or
   Excel files), and other advanced message system features. 

   Pine uses IMAP for accessing message folders on remote computers and
   MIME for sending multimedia or other binary files as attachments to
   normal messages. 

Subject: What is MIME?

   MIME (RFC 1521) stands for "Multipurpose Internet Mail Extensions". It
   is an Internet standard which allows transfer of binary files
   (word-processing documents, spreadsheets, images, sounds, etc) between
   any compliant mailers. You can get technical information about MIME
   from the RFC. Ongoing discussion on MIME takes place in the newsgroup
   comp.mail.mime. There is also a Frequently Asked Questions (FAQ) list
   that is posted regularly to comp.mail.mime and comp.answers. 

Subject: What is IMAP?

   IMAP stands for "Internet Message Access Protocol". An IMAP client
   program on any platform at any location on the Internet can access
   email folders on an IMAP server. While the messages appear to be
   local, they reside on the server until the client explicitly moves or
   deletes them.  The IMAP protocol is a functional (but incompatible)
   superset of POP. A principal advantage of IMAP over POP is that it
   permits using more than one computer to access your mail.  Using
   multiple computers with POP typically results in your mail ending up
   scattered across all of those computers. Another key advantage is
   IMAP's ability to selectively access parts of messages, e.g. you
   don't have to wait for a 2MB audio attachment to be retrieved until
   you specifically ask for it.  This is a big win over low-speed (e.g.
   dialup) connections.  For a detailed comparison of IMAP and POP, see
   the paper "Comparing Two Approaches to Remote Mailbox Access: IMAP
   vs. POP."
  
   IMAP is what allows Pine (or any other IMAP client) to access email
   on a remote mail server, usually one that is shared (central or
   departmental).  There is an IETF working group currently defining the
   IMAP4 revision to the IMAP2 specification (RFC-1176).  A copy of the
   latest IMAP draft may be obtained from ftp.cac.washington.edu in the
   file imap/latest-imap-draft

Subject: How can I get a copy of Pine?

   Pine is available via anonymous ftp from the pine directory of
   ftp.cac.washington.edu. See the Installation Instructions for Pine for
   more information. 

Subject: Is there a manual?

   The Pine program itself includes extensive online help.  Additional
   documentation may be found via anonymous FTP or via World-Wide-Web
   using the following URLs: 

        ftp://ftp.cac.washington.edu/pine
        http://www.cac.washington.edu/pine

   The Pine program itself also includes extensive online help. Other
   forms of access are planned for the future. 

Subject: What mailing lists and newsgroups are there dealing with Pine?

   The "comp.mail.pine" newsgroup is devoted to Pine.  It is
   bi-directionally gatewayed to the "pine-info" mailing list described
   below. 

   The following mailing lists deal with Pine and related topics: 
   
   [email-masked] 
          Pine-Info is a mailing list for the email program Pine. The
          mailing list includes discussion of Pine features, bugs,
          tricks, etc. Often technical and installation questions appear
          on the list. New releases, fixes and version of Pine are
          announced on the pine-info mailing list.
          
          For official announcements only, you may wish to see
          pine-announce instead of this list.
          
          To subscribe to pine-info, send a message to
          [email-masked] with 

        subscribe pine-info

   in the body of the message.
          
          Owners of this mailing list can be contacted at
          [email-masked]. 
          
   [email-masked] 
          Pine-Announce is a announcement list for the email program
          Pine. When new Pine products are released and old ones updated,
          a message goes out to this group describing the development. It
          is a very low volume list and includes no discussion
          whatsoever.
          
          _All messages to this list are automatically forwarded to
          pine-info, so it is not necessary to subscribe to both lists._
          
          To subscribe to pine-announce, send a message to
          [email-masked] with 

        subscribe pine-announce

   in the body of the message.
          
          Owners of this mailing list can be contacted at
          [email-masked].
          
   [email-masked] 
          This is the official mailing list for the IETF IMAP working
          group and other interested parties. Discussion of the evolving
          IMAP standard and related issues is conducted on this list.
          
          To subscribe to IMAP, send a message to
          [email-masked].
          
   [email-masked] 
          This list is for discussion of the C-Client library which is
          used by Pine and various other mail and IMAP clients and
          servers.

Subject: What are all these funny names in your examples?

   In an attempt to avoid confusion with real places or services we
   decided to make up a ficticious user for our examples. This person is
   John Smith, who is currently an art major at the University of Nowhere
   (nowhere.edu). He previously attended Elsewhere Community College
   (elsewhere.edu). His username is jsmith and he uses the following
   machines: 
   
   rembrandt.art.nowhere.edu 
          A Unix timesharing machine. 
          
   picasso.art.nowhere.edu 
          An SMTP server. 
          
   news.nowhere.edu 
          A Usenet News server which supports both NNTP and IMAP access. 
          
   davinci.art.nowhere.edu 
          A PC-compatible workstation running MS-DOS. 
          
   warhol.art.nowhere.edu 
          An IMAP server. 
          
   fozzie.elsewhere.edu 
          An IMAP server at Elsewhere Community College. 

Subject: How many sites use Pine?

   We don't have a good way to count the number of sites running Pine,
   but at last count over 4,000 sites in 40 countries had downloaded the
   Pine 3.89 distribution from ftp.cac.washington.edu. There are also
   several major archive sites that mirror the distribution, so the
   actual numbers are probably much higher. 

Subject: I have found a bug in Pine 3.05. Could you please fix it?

   When a bug is identified in an old release, there is a very strong
   possibility that the associated code has been re-written to the point
   that a fix will not apply to the current release.  Hence, if we can't
   reproduce the problem in the current version, our standard response
   will be to ask you to upgrade. 

Subject: If I postpone a Reply, there is no 'A' in the index after I resume and send it.

   This is a known limitation of the current release of pine. When you
   postpone a composition, Pine does not have any way to keep track of
   which message was being replied to (or that it was a reply at all).
   This limitation will be removed in a future release of Pine. 

Subject: "Folder Format Invalidated (consult an expert), aborted"

   The message "Folder Format Invalidated (consult an expert), aborted"
   means that Pine was reading your mail folder, and at the point in
   which it expected a start-of-message header line, it found something
   else.
   
   The ``format invalidated'' condition can happen in one of three ways: 
    1. bad data exists at the beginning of the folder. 
    2. data was appended to the folder after Pine initially read it, and
       the new data did not begin with a start-of-message-header. 
    3. the folder was modified without Pine being aware of it. 
       
   All three problems are generally caused by software external to Pine.
   
   Condition (1) can be determined by whether or not the problem repeats
   itself after restarting Pine. If restarting Pine does not make the
   problem go away, then you need to look at the actual file for the
   folder and see what is wrong with the very first line. In particular,
   make sure that there are no blank lines at the beginning of the file
   and that the first character of the folder file is a capital ``F'' ,
   the second an ``r'', the third an ``o'', etc.  In the case of an 
   INBOX, you may want to rename the folder so that new mail can be
   delivered while repairs on the corrupt folder are being done. 
   
   Condition (2) may be caused by a mail delivery process (e.g.
   /bin/mail) which writes some characters other than ``From '' at the
   beginning of the new data.
   
   Condition (3) is caused by another program manipulating the mail
   folder without following the normal folder locking protocols.  This
   is a general problem on UNIX. 
   
   Conditions (2) and (3) have also been known to occur when accessing
   folders via NFS, if the information returned by the stat() and read()
   system calls do not correspond with each other as a result of NFS
   attribute caching.
   
   Restarting Pine on that folder always clears conditions (2) and (3).
   If the problem is chronic, it may be worth an investigation to
   determine its cause. Usually, it is due to the misbehavior of some
   external software. The reason why Pine gives up with conditions (2)
   and (3) is that it does not want to risk damaging user data by
   guessing what is right. Pine never writes to the folder unless it is
   absolutely sure it knows what it is doing.
   
   There are some steps which can be taken to reduce the risk of these
   conditions coming up. Some of these steps may require the assistance
   of your system adminstrator (or whomever it was that built and
   installed Pine on your system): 
    1. Use IMAP instead of NFS to access remote folders. Problems with
       locking over NFS are perhaps the single most important cause of
       user difficulties.  Using IMAP eliminates this class of problem.
    2. Consider enabling the mbox driver in Pine. If the mbox driver is
       enabled, mail is transferred from the /usr/spool/mail mail into a
       file called mbox in your home directory, if mbox exists. The home
       directory mbox file is then your INBOX. This has the advantage
       that Pine and the mail delivery system are less often in
       contention for the INBOX, and never both trying to update it.
       Pine only empties the /usr/spool/mail file, it never tries
       updating it. 
    3. Be careful not to run other programs that modify your folders
       while you are running Pine. Such programs may change the folder
       out from under Pine, and lead Pine to conclude that there is a
       problem with its view of the file. 

Subject: What is folder locking and how does it work?

   Locks are used by Pine and other mail programs to prevent damage from
   occurring to the mail file when multiple programs try to write to the
   file at the same time.
   
   Because there are many different schemes of mail file locking used on
   UNIX, Pine implements all of them. The result is a lot of complexity.
   
   There are several reasons why locking needs to be done:
   
    1. If you want to read the mail file, you want to make sure that no
       other process will modify the mail file while you are reading it.
       
    2. If you want to write to the mail file, you want to make sure that
       no other process is accessing the mail file while you are writing
       it.
       
    3. If you have the mail file open, you want to make sure that no
       other process can alter any of the internal contents of the mail
       file that you have read, but it is OK if another process appends
       new data to the mail file.
       
    4. If you want to alter any of the internal contents of the mail
       file, you want to make sure that no other process has the mail
       file open.
       
   There are several mechanisms of locking:
   
     * The creation of a file which has the same name as the mail file,
       but with a suffix of ".lock" (for example, this lock for
       /usr/spool/mail/isma is named /usr/spool/mail/isma.lock). This
       file accomplishes locks (1) and (2) above. This is an exclusive
       lock. 
     * The use of an flock() with LOCK_SH on the mail file. This
       accomplishes lock (1), and prevents lock (2). Multiple processes
       can do this. 
     * The use of an flock() with LOCK_EX on the mail file. This
       accomplishes lock (2), and prevents lock (1). This is an exclusive
       lock. 
     * The use of an flock() with LOCK_EX on a file on /tmp. The file
       name used depends upon the version of Pine. This accomplishes
       locks (3) and (4). This is an exclusive lock. 
       
   On SVR4-based systems, the lockf() subroutine or fcntl() system call
   it used instead of flock(). It is rumored that this creates a kind of
   lock file as well, but this has not been directly verified.
   
   _NOTE: flock() on BSD systems does not work over NFS, so only the most
   basic .lock file locking -- locks (1) and (2) happen over NFS. On SVR4
   systems, fcntl() locking attempts to work over NFS, but there are
   known problems in the rpc.lockd daemon which have caused hangs if an
   application beats on the mechanism too much (and Pine beats on it).
   All of the above mechanisms work reliably over IMAP connections._
   
   _[MRC]_ 

Subject: What happens when two Pine sessions access the same mailbox at the same time?

   This varies depending on what format your folders are stored in. With
   the default Berkeley format, the last session to open a folder will
   get full access to the folder and the previous session(s) will be
   changed to read-only access. When a folder is read-only, you will not
   see any further updates to that folder until it is reopened with full
   access. Currently the INBOX cannot be reopened without exiting and
   restarting Pine. With the Tenex format, any number of sessions can
   simultaneously have full access to a folder, with the exception that
   expunging is disabled. See "What is a Tenex mailbox and why should I
   use it?" for more information. 

Subject: Why did I get the message "locked, override in _XXX_ sec"?

   The message "locked, will override in _xxx_ seconds" occurs when Pine
   has discovered that some other mail program claims to be accessing
   your mail folder (i.e. _folder_.lock exists). This is a very low-level
   lock used by programs such as the system mailer in delivering mail,
   and by certain programs such as mail, elm, babyl, mm, etc. Supposedly,
   this lock is only to be acquired and held for a very short period of
   time (less than a second).
   
   It starts with 285 seconds, retries every second, and issues that
   message every 15 seconds. The total period of time, 5 minutes, is the
   time that it will keep on trying before it concludes that the lock is
   false -- that is, that whatever program locked the folder forgot to
   unlock it (perhaps it crashed) -- and Pine will go ahead and claim the
   lock for itself.
   
   This is not due to a conflict between two copies of Pine, since Pine
   interlocks against itself in a higher-level fashion. 
   
   _NOTE: On some systems with 14 character filename limits, attempting
   to open a folder with a 14 character name (e.g. saved-messages) will
   trigger this sequence. Folder names should be limited to 9 characters
   or less on those systems._ 

Subject: Why is a charset=US-ASCII attachment sent using BASE64 encoding?

   Pine BASE64-encodes all attachments, including text, in order to
   assure that they are not modified in transit. The goal is make sure
   file attachment in Pine is as dependable as FTP (and BASE64 is safer
   than Quoted-Printable). A good example of why this is handy is when we
   recently asked some folks to attach their addressbooks to help us
   track down problems in 3.90, we didn't have to worry about whether a
   gateway had modified a tab or trailing blanks, etc, etc.

Subject: How do I keep all of the names from showing up at the top of the message?

   Put addresses and/or list from your address book in the Bcc: (blind
   carbon copy) header field. You will see all the names and addresses as
   you compose the message, but they are erased before arriving in other
   people's INBOXes. The Bcc: header is not displayed automatically in
   the default Pine configuration, so you may need to use the rich
   headers command (Ctrl-R) while the cursor is in the header to expose
   it. 

Subject: How do I use Ispell with Pine (and Pico)?

   Here are a couple ways to use Ispell within Pine: 
    1. Set your alternate-editor to ispell, then ^_ in the composer
       invokes ispell. To do this set "editor=/usr/local/bin/ispell" in
       your .pinerc file. This may be set within Pine via the _OPTIONS_
       task of the _SETUP_ command from the main menu.
       
       Now, when you press ^_ (Control-Underscore) in Pine, you will
       execute the ispell program in its native mode. Press ? for help.
       Press I to insert unknown words into the personal dictionary. You
       can still press Ctrl-T to use the standard pine spell-checking
       program (which will -not- use your personal dictionary). See 'man
       ispell' for more information on the ispell program.
       
    2. Pine already checks the SPELL environment variable so you can
       create the following script and name it spell. 

     #!/bin/sh
     ispell -l | sort | uniq 

   To make Ctrl-T in pine use 'ispell' and your '$HOME/.ispell_words'
       dictionary: 
          + make the above script file 'spell' in your home directory 
          + make it executable: 'chmod u+x spell' 
          + set the environment variable SPELL: 'setenv SPELL
            $HOME/spell' (you may include this command in your .profile,
            .cshrc or .login file) 

       Now, when you press Ctrl-T in Pine, you will execute the ispell
       program, and it will recognize words stored in the private
       dictionary. The screen display will look like pine is using the
       standard spell-checking program. Unfortunately, this method does
       not allow the user to Insert words into the private dictionary.
       However, this might be useful with a central script file (setenv
       SPELL ...) and a central private dictionary (ispell -p ...) to
       provide a common private dictionary for an entire workgroup. The
       manager could add items to the private dictionary; ordinary pine
       users would use the private dictionary (Ctrl-T), but they could
       not change it. 
       
   To use ispell with pico, implement the 'ispell' program via ^T
   (CTRL-T) (using the script file) in addition to implementing it via ^_
   (CTRL-_) (using the .pinerc file). 
     * Use Ctrl-_ in Pine (it won't work in Pico) for full-featured
       ispell. 
     * Use Ctrl-T in Pico to use the ispell program and your
       .ispell_words dictionary (but without the full ispell
       functionality). 
       
   You can use Ctrl-T/ispell in Pine also, but why bother when Ctrl-_
   works better. 
   
   _[Mike Ramey <[email-masked]>]_ 

Subject: How can I have a signature automatically appended to my mail messages?

   Using your favorite text editor (e.g. Pico), create a file in your
   home directory called .signature containing the text you want appended
   to each message. For more detailed information see The Signature and
   Finger Frequently Asked Questions list which is posted periodically to
   the comp.mail.pine and comp.mail.misc newsgroups.
   
   PC-Pine users should put their signatures in the file \PINE\PINE.SIG.

Subject: How do I read News with Pine?

   Three ways to access news via Pine: 
    1. Local News. If news is stored on the same machine you run Pine on,
       you can specify: 

        news-collections=News *[*]

    2. Via NNTP. Your .newsrc file must be on the machine where Pine is
       running. Assuming news is stored on the machine news.nowhere.edu,
       a typical .pinerc entry would be: 

        news-collections=News *{news.nowhere.edu/nntp}[*]

       Alternatively, if the nntp-server variable is set, your
       news-collections will default to NNTP access from the same server.

    3. Via IMAP. Your .newsrc file must be on the machine where news is
       stored. Assuming news is stored on the machine news.nowhere.edu, a
       typical .pinerc entry would be: 

        news-collections=News *{news.nowhere.edu}[*]

   The advantage of option #3 is that the same .newsrc can be used for
   both Unix Pine and PC-Pine. The disadvantage is that you must have an
   account on the machine that stores the news and runs the NNTP server.

Subject: Can I post news with Pine?

   Versions of Pine prior to Pine 3.90 do not support posting. In Pine
   3.90 and later you can enter a list of newsgroups on the newsgrps:
   header to post a message. 

Subject: How do I "paste" an address from the addressbook into the text of a message?

   Pine does not currently support this directly, but here is a
   work-around: 
    1. Move the cursor to the Cc: line. 
    2. Enter the nickname or press Ctrl-T to search the addressbook and
       select the entry. 
    3. Use Ctrl-K to delete that address from the Cc: line. 
    4. Move the cursor where you want it in the body of the message. 
    5. Press Ctrl-U to insert the address. 
       
   This is kind of a round-about way to get the job done, but it works...

Subject: How can I filter messages into different incoming folders?

   Pine does not do delivery filtering. That function is done by other
   programs, such as "procmail", or "filter" or "deliver".
   
   Once you have set-up your delivery filtering, e.g. via the "filter"
   program, then you will have new mail arriving in several different
   mailboxes/folders, in addition to your INBOX.
   
   So then the question becomes, how do you access those new "incoming
   message" folders that your favorite delivery filter program has
   created? Pine's answer is to let you specify them in your .pinerc, as
   in the example:

 
incoming-folders=Art151           {warhol.art.nowhere.edu}filter/to-art151,
                 Art-L            {warhol.art.nowhere.edu}filter/to-Art-L,
                 Old-Student-Acct {fozzie.elsewhere.edu}INBOX

   In this case, the pinerc entries presume that your delivery filtering
   program has been configured to put mail relating to the Art151 class
   into the folder "filter/to-art151" and mail relating to the Art-L
   mailing list into "filter/to-Art-L". 
   
   From the Folders List screen, you can then easily access those
   folders. Eventually we will have a way to indicate which of these may
   have new mail waiting for you, so that you don't "forget" that you
   have more than one place to look for new mail...

Subject: Can I define a Reply-To: header?

   Yes. This is a new feature of Pine 3.90. It is handled as a "custom
   header" and can be added into that field via Pine's new configuration
   screen.

Subject: Can I execute Pine from a shell script so I can use my addressbook?

   Not currently. 

Subject: When I get new mail, xbiff lets me know about it, but pine doesn't know about it.

   There are currently two ways to force a new mail check. 
     * At the last message in a folder, press 'N' 4-5 times. 
     * Press `Ctrl-L' (Refresh Display). 

Subject: How can I read a ROT13 encoded message?

   When viewing the message, use the '|' (Pipe) command and give it the
   following: tr '[A-Za-z]' '[N-ZA-Mn-za-m]' 

Subject: Can Kerberos or AFS authentication be used with Pine?

   Not yet, but Kerberos support is planned for a future release of
   Pine. If you have access to Kerberos or AFS compatible IMAP clients
   already, the following information may be useful. 
  
   The current version of imapd does not support AFS or Kerberos
   authentication.  However, the routine which validates authentication
   is designed as a drop-in module, to allow you to replace with
   alternative authentication schemes such as AFS, Kerberos, S/Key, etc. 
   
   This routine is server_login(). Depending upon which version of
   c-client you have, it is either in the os__xxx_.c (where _xxx_ is the
   name of your port) or it is in a file named log__yyy_.c which is
   included by the os_xxx.c file.
   
   The log__yyy_.c is usually log_std.c (std for "standard UNIX"), but it
   may be log_sv4.c (SVR4) or a couple of other variants. This file only
   contains that one routine, so it should be a simple matter to modify
   that file and rebuild imapd.

Subject: Can PC-Pine be used with a POP server?

   No.  Neither Pine nor PC-Pine currently support POP's offline mail
   model (wherein pending mail is pulled from the mail server to the
   local machine and deleted from the server).  However, it is likely
   that this model will be supported, with a choice of either IMAP or
   POP as the access protocol, in a future release. 

Subject: What is a Tenex mailbox and why should I use it?

   Using the Tenex format for INBOXes allows multiple sessions (or
   mulitple users, subject to the usual access controls) to have *almost*
   full Read-Write access to the INBOX. The only limitation on full RW
   access is that if there are multiple sessions at a given moment, no
   one can do an Expunge. However, message state changes (e.g. marking a
   msg as deleted) *can* be done, and this state is preserved across
   sessions. 
   
   If an explicit Expunge cmd fails, it will say so and tell you that the
   mailbox is in use by another process. When there is only one session
   left using that mailbox, expunge will resume working again.
   
   In contrast: the normal Berkeley style folders can have only one RW
   client at a time, so _given the current software_ the latest session
   steals the RW lock away from any previous session, with the earlier
   session becoming RO.

Subject: Where does Unix Pine look for configuration information?

   In Pine 3.90, the Release Notes (Press "R" on the Main Menu) contain
   a section on Configuration, including default file names and
   environment variables. 

   In brief, Unix Pine uses three configuration files:  a system-wide
   file /usr/local/lib/pine.conf, a system-wide non-overridable file
   /usr/local/lib/pine.fixed, and a personal configuration file
   ~/.pinerc. There are certain options which are only found in system
   wide configurations, others only found in personal configurations, and
   still others found in both. For settings found in both pine.conf and
   .pinerc, values in .pinerc take precedence over those in pine.conf, 
   and settings in pine.conf.fixed take precedence over everything.
   
   If you need to generate a "blank" copy of the system wide
   configuration files, run "pine -conf > /usr/local/lib ". Pine
   automatically generates a .pinerc when a user starts Pine for the
   first time.
   
   Starting with Pine 3.90, almost all personal configuration can be
   accomplished through the _SETUP_ command from the main menu.

Subject: Where does PC-Pine look for configuration information?

   In Pine 3.90, the Release Notes (Press "R" on the Main Menu) contain
   a section on Configuration, including default file names and
   environment variables. 

   In brief, PC-Pine uses the following rules for finding config and
   support files: 

    1. The location of the PINERC is searched for in the following order
       of precedence: 
         1. File pointed to by PINERC environment variable 
         2. $HOME\PINE\PINERC 
         3. A file named PINERC in the same directory as PINE.EXE 
    2. The HOME environment variable, if not set, defaults to root of the
       current working drive. 
    3. The default for external files (PINE.SIG and ADDRBOOK) is the same
       directory as the PINERC file. 
    4. The support files (PINE.HLP and PINE.NDX) are searched for in the 
       same directory as PINE.EXE. 
            
   Starting with Pine 3.90, almost all personal configuration can be
   accomplished through the _SETUP_ command from the main menu.

Subject: How do I make Pine work with my older terminal?

   Pine does not support some older terminals (e.g. tvi925, WYSE-60) very
   well. Some problems can be overcome with a proper termcap entry, but
   others, such as handling cursor keys, do not have a good solution.

Subject: How do I configure Pine to not leave mail in /usr/spool/mail?

   You have several options:
   
    1. Leave inbox in /usr/spool/mail, but turn on the Pine option to
       prompt users to move read messages to a folder in their home
       directory upon exiting Pine. 
    2. Modify your mail delivery program to deliver mail directly into
       the user's home directory, and specify that inbox-path in your
       global pine.conf (See the "tmail" program on
       ftp.cac.washington.edu for an example.) 
    3. "touch mail.txt" in each home directory, which will cause Pine
       (upon startup) to pull mail from /usr/spool/mail into ~/mail.txt
       -- however, mail.txt will be a Tenex-format, rather than Berkeley
       mail format folder (faster, but non-standard). 
    4. Link in the "mbox" driver when you build Pine. This driver will
       (upon Pine startup) pull mail from /usr/spool/mail into ~/mbox,
       which will be a Bky-format folder. 

Subject: How can someone without a MIME-aware mail program decipher an attachment?

   Regarding attachments: Pine uses the MIME Internet standard for this.
   MIME (Multipurpose Internet Mail Extensions) uses "Base64" encoding
   rather than uuencode, because uuencode uses characters that are
   transformed by some email gateways, and there are also several
   incompatible versions of uuencode.
   
   However, you can certainly uuencode a file outside of pine, then use
   the Composer's Ctrl-R (file inclusion) command to insert the encoded
   file in the message.
   
   If you use Pine's attachment feature, your recipient does need to have
   MIME-capable software. Fortunately, this is not hard to find. Even the
   major proprietary mail vendors have committed to MIME support, but
   some of their upgraded products are still some months away. One
   product which can decipher a MIME attachment is munpack from Carnegie
   Mellon. It is available from ftp.andrew.cmu.edu in the /pub/mpack
   directory.

Subject: How do I convert a Sun Mailtool attachment to MIME format?

   A perl script (and conversion to C of same) that converts OpenWindows
   mail to MIME. Body parts currently supported are: text, gif, Sun
   rasterfile (converted to image/gif), postscript, and audio. Other
   types default to application/octet-stream. It's easy to extend the set
   of types supported and to add conversions, if necessary. 
   
   The script requires uuencode, uudecode, zcat (aka uncompress), and the
   "convert" program from ImageMagick. If you don't have ImageMagick you
   can probably substitute the pbm stuff with little fuss. 
   
   The program is available via ftp from cs.utk.edu in
   pub/MIME/sun-to-mime.perl or pub/MIME/sun-to-mime.c
   
   _[Keith Moore <[email-masked]>]_

Subject: How do I convert Berkeley Mail aliases to Pine Addressbook?

   The Pine source distribution includes a shell script to do this in the
   contrib/utils directory. It is called brk2pine.sh. 

Subject: How do I convert Elm aliases to Pine Addressbook?

   Here's a little script one of our UNIX folks worked up to handle
   conversion of elm aliases to pine alias form (pretty simple syntax
   substitution). If you execute it multiple times it will keep adding
   another set of your elm aliases to your pine addressbook. 

#!/bin/csh
#!/bin/csh -vx
# convert elm aliases.text to pine addressbook
# Greg Gustafson
# UMD Information Services
# January 1993
#
if -r $HOME/.elm/aliases.text then
   if -e $HOME/.addressbook then
      set n=1
      while (-e $HOME/.addressbook$n)
         @ n++
      end
      mv $HOME/.addressbook $HOME/.addressbook$n
   endif
   ex - $HOME/.elm/aliases.text 

_[Joel Ness <[email-masked]>]_

Subject: What are the current versions of Pine and related software?

   The current version of Pine is 3.90. The current version of Pico is
   2.4. 

Subject: What is new in this version of Pine?

   These are the changes and improvements since Pine 3.89: 
     * Finished all the "Not implemented yet" commands: 
          + Bounce (Remail) 
          + Flag (Set message status) 
          + Pipe (Pipe msg to external cmd; Unix only) 
          + Select,Apply,Zoom (Aggregate operations) 
          + Setup/Config (Pinerc configuration screen) 
     * News posting 
     * News subscription/unsubscription 
     * Multiple address books 
     * Postpone multiple messages 
     * Customizable headers for Composer 
     * Mailcap support 
     * Improved support for multiple incoming message folders 
     * enable-alternate-editor-implicitly feature (except for editing
       headers) 
     * All .pinerc features now settable from command line 
     * Way to control which options are user-configurable (Unix only)
     * Way to have Save *not* implicitly delete 
     * Way to use current-working-directory for Export, Read File, etc. 
     * A _preliminary_ version of PC-Pine for Windows/Winsock (but not 
       OS/2) 

Subject: When is the next release of Pine (tentatively) scheduled?

   We don't know right now, we just released this version.  Besides, our
   track-record on meeting projected release schedules is terrible, so
   you shouldn't believe any dates we are foolish enough to suggest
   anyway. 

Subject: What new features will the future releases of Pine include?

     * Additional MIME support, esp. controlling file TYPING 
     * PEM and/or PGP support 
     * External directory services access 
     * Kerberos support 
     * RFC 1522 header encoding for 8bit character sets 
     * Location independence of support files 
     * Offline support 
     * Hierarchy support (awaits IMAP4) 
     * Answered flag not set if Reply is postponed (awaits IMAP4) 
     * Faster detection of folders with Recent messages (awaits IMAP4) 
     * Faster fetching of headers (awaits IMAP4) 
     * Determination of which flags are permanent (awaits IMAP4)